#pragma once

#include "Messages.h"

namespace Passer::Control {

class Participant {
public:
  unsigned char buffer[1024];

  virtual bool SendBuffer(unsigned char bufferSize);
  virtual bool PublishBuffer(unsigned char bufferSize);

  void ReceiveData(unsigned char bufferSize);

protected:
  virtual void ProcessNetworkIdMsg(NetworkIdMsg msg);
  virtual void ProcessInvestigateMsg(InvestigateMsg msg);
  virtual void ProcessThingMsg(ThingMsg msg);
  virtual void ProcessPoseMsg(PoseMsg msg);
  virtual void ProcessCustomMsg(CustomMsg msg);
};

} // namespace Passer::Control
using namespace Passer::Control;